Package com.oracle.truffle.object.basic

## Class DynamicObjectBasic

- java.lang.Object
- - com.oracle.truffle.object.DynamicObjectImpl
  - - com.oracle.truffle.object.basic.DynamicObjectBasic

All Implemented Interfaces:
  `DynamicObject`, `TypedObject`, `java.lang.Cloneable`

    public class DynamicObjectBasic
    extends DynamicObjectImpl

### Nested Class Summary

Nested Classes
`protected static interface` `DynamicObjectBasic.DynamicField`

### Nested classes/interfaces inherited from interface com.oracle.truffle.api.object.DynamicObject

`DynamicObject.FlagsFunction`

### Field Summary

### Fields inherited from class com.oracle.truffle.object.DynamicObjectImpl

`reshapeCount`

### Constructor Summary

Constructors
`DynamicObjectBasic​(Shape shape)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected boolean` `checkExtensionArrayInvariants​(Shape newShape)` Check whether the extension arrays are in accordance with the description in the shape.
`protected DynamicObject` `cloneWithShape​(Shape currentShape)`
`protected void` `growObjectStore​(Shape oldShape, Shape newShape)` Simpler version of `resizeObjectStore(com.oracle.truffle.api.object.Shape, com.oracle.truffle.api.object.Shape)` when the object is only increasing in size.
`protected void` `growPrimitiveStore​(Shape oldShape, Shape newShape)` Simpler version of `resizePrimitiveStore(com.oracle.truffle.api.object.Shape, com.oracle.truffle.api.object.Shape)` when the object is only increasing in size.
`protected void` `initialize​(Shape shape)`
`protected void` `reshape​(ShapeImpl newShape)`
`protected void` `resizeObjectStore​(Shape oldShape, Shape newShape)`
`protected void` `resizePrimitiveStore​(Shape oldShape, Shape newShape)`

### Methods inherited from class com.oracle.truffle.object.DynamicObjectImpl

`changeFlags, changeFlags, clone, copyProperties, debugDump, debugDump, define, define, delete, equals, get, getShape, getTypeIdentifier, hashCode, isEmpty, set, setShape, setShapeAndGrow, setShapeAndResize, setShapeAndResize, size, toString, updateShape`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### DynamicObjectBasic

    public DynamicObjectBasic​(Shape shape)

### Method Detail

#### initialize

    protected final void initialize​(Shape shape)

Specified by:
  `initialize` in class `DynamicObjectImpl`

#### growObjectStore

    protected final void growObjectStore​(Shape oldShape,
                                         Shape newShape)

Simpler version of `resizeObjectStore(com.oracle.truffle.api.object.Shape, com.oracle.truffle.api.object.Shape)` when the object is only increasing in size.

Specified by:
  `growObjectStore` in class `DynamicObjectImpl`

#### growPrimitiveStore

    protected final void growPrimitiveStore​(Shape oldShape,
                                            Shape newShape)

Simpler version of `resizePrimitiveStore(com.oracle.truffle.api.object.Shape, com.oracle.truffle.api.object.Shape)` when the object is only increasing in size.

Specified by:
  `growPrimitiveStore` in class `DynamicObjectImpl`

#### resizeObjectStore

    protected final void resizeObjectStore​(Shape oldShape,
                                           Shape newShape)

Specified by:
  `resizeObjectStore` in class `DynamicObjectImpl`

#### resizePrimitiveStore

    protected final void resizePrimitiveStore​(Shape oldShape,
                                              Shape newShape)

Specified by:
  `resizePrimitiveStore` in class `DynamicObjectImpl`

#### checkExtensionArrayInvariants

    protected final boolean checkExtensionArrayInvariants​(Shape newShape)

Check whether the extension arrays are in accordance with the description in the shape.

Specified by:
  `checkExtensionArrayInvariants` in class `DynamicObjectImpl`

#### cloneWithShape

    protected final DynamicObject cloneWithShape​(Shape currentShape)

Specified by:
  `cloneWithShape` in class `DynamicObjectImpl`

#### reshape

    protected final void reshape​(ShapeImpl newShape)